<?php

Class SGallery extends Page {

    static $singular_name = 'SGallery';
    static $plural_name = 'SGalleries';
    static $icon = '';
    static $db = array(
        'GalleryDesc' => "HTMLText",
        'AlbumFolderID' => 'Int',
        'setPlugin' => 'Text',
        'ItemsPerPage' => 'Int(2)',
        'ThumbnailImageWidth' => 'Int(4)',
        'ThumbnailImageHeight' => 'Int(4)',
        'FullImageWidth' => 'Int(4)',
        'FullImageHeight' => 'Int(4)',
        'ResizeMethod' => "Enum('CroppedImage,SetWidth,Setheight','CroppedImage')"
    );
    static $has_one = array(
        'Folder' => 'Folder',
        'CoverImage' => 'Image'
    );
    public static $has_many = array(
        'Images' => 'SGalleryImage'
    );
    public static $defaults = array(
        'ItemsperPage' => '10',
        'ThumbnailImageWidth' => '100',
        'ThumbnailImageHeight' => '100',
        'FullImageWidth' => '100',
        'FullImageHeight' => '100',
        'setPlugin' => 'Default',
    );

//*
    function getCMSFields() {
        $fields = parent::getCMSFields();
        /*
         *  Add extra basic fields to the CMS + Extra Tab 
         *  $newFieldsArray = list of fields need to be added to tab
         *  $newFieldsArray MUST be used to add array of fields as fields need to be declared before they can be added to a tab !
         */

// Settings Tab
        $newFieldsArray = array(
            new UploadField("CoverImage"),
            new TextareaField("GalleryDesc"),
            new TextField("setPlugin"),
//            new DropdownField('ResizeMethod', 'ResizeMethod', singleton($this)->dbObject('ResizeMethod')->enumValues()),
            new TextField('ItemsPerPage'),
            new TextField('ThumbnailImageWidth'),
            new TextField('ThumbnailImageHeight'),
            new TextField('FullImageWidth'),
            new TextField('FullImageHeight')
        );

        $CategotiesForTable = Dataobject::get("SGalleryImageCategory");
        /*
         * Add Gallery Section to the page using has_many relation + GridFeild 
         */
        $gridFieldConfig = GridFieldConfig_RelationEditor::create();
        $gridFieldConfig->addComponents(
                new GridFieldSortableRows("SortID")
        );
        $gridField = new GridField("Images", "SGalleryImage", $this->Images(), $gridFieldConfig);
        $gridField2 = new GridField("Categories", "Categories", $CategotiesForTable);

        /* Customize the List Display in the CMS 
         *         
          $gridField->getConfig()->getComponentByType('GridFieldDataColumns')->setDisplayFields(array(

          ));
         * 
         */

        /* Auto list folders in SGallery/plugins/ */
        /*
          $album = Folder::get()->filter('Filename', 'assets/plugins/')->first();;
          //        var_dump($album);
          //        Debug::dump($album);die;

          if ($album) {
          $tree = new TreeDropdownField(
          'AlbumFolderID',
          _t(
          'SGallery.CHOOSEALBUMFOLDER', 'Choose album folder (subfolder assets/plugins/)'
          ),
          'Folder'
          );
          $tree->setTreeBaseID((int) $album->ID);
          $fields->addFieldToTab("Root.Main", $tree, 'Content');
          }
         * 
         */


        /* Add Fields to tabs */
        $fields->addFieldsToTab("Root.Settings", $newFieldsArray, "");
        $fields->addFieldToTab("Root.GalleryImages", $gridField);
        $fields->addFieldToTab("Root.Categories", $gridField2);


        return $fields;
    }

    /*
     * Attempt to create custom folder for each SGallerypage 
     * 
      function findOrMakeFolder() {
      $Title = SiteTree::generateURLSegment($this->Title);
      if ($this->Folder() && $this->Folder()->exists()) {
      $folder = $this->Folder();
      } else {
      $folder = Folder::findOrMake($Title);
      $folder->write();
      }
      $folder->Name =$Title;
      $folder->Title = $Title;
      $this->FolderID = $folder->ID;
      $folder->write();
      }
     * 
     */

    function onBeforeWrite() {
        parent::onBeforeWrite();
//$this->findOrMakeFolder();
    }

    function onBeforeDelete() {
        parent::onBeforeDelete();
    }

    public static $default_values = array();

    function getImagesForCount() {
        
    }

}

class SGallery_Controller extends Page_Controller {

    function init() {
        parent::init();
    }

    function RenderGallery($templatename="Default") {

// checks if setPlugin is changed in the CMS 
        if (isset($this->data()->setPlugin)) {
            $templatename = $this->data()->setPlugin;
            $thisClass = $this->data()->ClassName;
        }
        $renderWithArray = array(
            "$thisClass-" . $templatename
        );

        if (isset($templatename)) {
            return $this->renderWith($renderWithArray);
        }
    }

    /*
     * * ***********************************
     * Pagination & getByCategory Methods
     * * ***********************************
     */

    function getImages($newDataList=NULL) {
        if ($this->newImagesByCategory) {
            return $this->newImagesByCategory;
        } elseif ($newDataList) {
            return $newDataList;
        } else {
            return $this->data()->Images();
        }
    }

    public function Pagination($getListToPaginate=NULL) {
        $getImages = $this->getImages();
        $PaginatedList = new PaginatedList($getImages, $this->request);
        $PaginatedList->setPagelength($this->data()->ItemsPerPage);
        return $PaginatedList;
    }

    public function getImagesByCategory() {
        $getCategory = func_get_args();
//        $getCategory = 0;
        $CategoryFilter = Dataobject::get("SGalleryImageCategory")->filter(array(
                    'Title' => $getCategory
                ))->first()->SGalleryImages();

        $this->newImagesByCategory = $CategoryFilter;

//        return $this->getImagesDataList();
    }

}
