<?php

class SGalleryImage extends DataObject {
    /*
      public static $plural_name = 'Gallery Images';
      public static $singular_name = 'Gallery Image';
     */

    static $db = array(
        'Name' => 'Varchar(255)',
        'Caption' => 'Text',
        'ImageLinkURL' => 'Text',
        'ImageLinkHTML' => 'Text',
//        'ImageLinkDropdown' => 'Text',
        'SortID' => 'Int',
        'isFeatured' => 'boolean',
        'isTopItem' => 'boolean'
    );
    static $has_one = array(
        'Image' => 'Image',
        'SGallery' => 'SGallery'
    );
    static $has_many = array(
//        'SGalleryImageTextFields' =>'SGalleryImageTextField'
    );
    static $many_many = array(
        'Categories' => 'SGalleryImageCategory'
    );
// Summary fields
    public static $summary_fields = array(
        'SortID' => 'SortID',
        'Image.CMSThumbnail' => 'Image',
        'Title' => 'Title',
        'ID' => 'ID'
    );
    public static $default_sort = 'SortID Desc';
    public static $defaults = array(
    );
    /*
     * CMSFields
     * **************************************
     */

    function getCMSFields() {
        $fields = parent::getCMSFields();
        $gridFieldCategoriesConfig = GridFieldConfig_RelationEditor::create();
        $gridFieldCategories = new GridField("Categories", "Categories", $this->Categories, $gridFieldCategoriesConfig);

        //*//   
        $newFieldsArray = array(
            new TextField('Name'),
            new TextAreaField('Caption'),
            new TextField('ImageLinkURL'),
//            new TextField('ImageLinkDropdown'),
            new CheckboxField('isFeatured'),
            new CheckboxField('isTopItem')
        );
        $newFieldsArray_Advanced = array(
            new TextField('SortID'),
            new TextAreaField('ImageLinkHTML'),
        );

        //*/
//      $fields->findOrMakeTab('Root.SubOne.xxx');
        $fields->addFieldsToTab("Root.Main", $newFieldsArray);
        $fields->addFieldsToTab("Root.Advanced", $newFieldsArray_Advanced);
        $fields->addFieldsToTab("Root.Categories", $gridFieldCategories);
        return $fields;
    }

    /*
     * Extra Functions
     * **************************************
     */

    function onBeforeWrite() {
        parent::onBeforeWrite();
        if (!$this->SortID) {
            $this->SortID = $this->getNextSortID();
        }
    }

    function onAfterWrite() {
        parent::onAfterWrite();
        /*
          $getDataList = $this->SGallery()->Images();
          if (!$getDataList || $getDataList->Count() == 0) {
          $nextSortID = 22;
          } else {

          $nextSortID = $getDataList->last()->SortID+1;
          }
          if (!$this->SortID && $this->SGalleryID) {
          $this->SortID = $nextSortID;
          $this->write();
          }
         * 
         */
    }

    function getNextSortID() {
        $getDataList = $this->SGallery()->Images();
//        $parentID = $this->SGallery()->ID;
//        $ParentImages = $this->SGallery()->Images();
//        $ParentLastImageSortID = $this->SGallery()->Images()->last()->SortID;

        if (!$getDataList || $getDataList->Count() == 0) {
            return NULL;
        } else {

            return $getDataList->first()->SortID + 1;
        }
    }

    public static function ThumbnailImage() {
        
    }

    public static function FullImage() {
        
    }

    public function getCategories() {
        return $this->Categories();
    }

    public function test() {
        return print $this->getNextSortID();
    }

}

/*

    function onBeforeWrite() {
        parent::onBeforeWrite();
        if (!$this->SortID) {
            $this->SortID = $this->getNextSortID();
        }
    }


    function getNextSortID() {
        $getDataList = $this->SGallery()->Images();
        if (!$getDataList || $getDataList->Count() == 0) {
            return NULL;
        } else {

            return $getDataList->last()->SortID + 1;
        }
    }
 * 
 */